import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.util.ArrayList;
/**
 * Write a description of class Man here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Man extends Actor
{
    double[] xLoc = {50,50,50,50,-50,-50,-50,-50};
    double[] yLoc = {50,50,-50,-50,50,50,-50,-50};
    double[] zLoc = {50,-50,50,-50,50,-50,50,-50};
    int[][] order = {
        {0,1,3,2},
        {0,2,6,4},
        {0,4,5,1},
        {1,3,7,5},
        {2,3,7,6},
        {4,5,7,6}
    };
    Color[] colors = {
        Color.green,
        new Color(Color.white.getRed()-3,Color.white.getGreen(),Color.white.getBlue()),
        Color.red,
        Color.yellow,
        Color.orange,
        Color.blue
    };
    float scale = .5f;
    int pastX = 0;
    int pastY = 0;
    int cubeX = 0;
    int cubeY = 0;
    public Man()
    {
        setImage(new GreenfootImage(600,400));
        for(int i=0;i<8;i++)
            {
                zLoc[i] = zLoc[i]*scale;
                yLoc[i] = yLoc[i]*scale;
                xLoc[i] = xLoc[i]*scale;
            }
        draw();
    }
    /**
     * Act - do whatever the Man wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if(Greenfoot.mouseDragged(null))
        {
            MouseInfo m = Greenfoot.getMouseInfo();
            if(pastX != 0&&Math.abs(pastX-m.getX())<40&&Math.abs(pastY-m.getY())<40){
                yAxis((m.getX()-pastX)/3);
                xAxis((m.getY()-pastY)/3);
            }
            pastX = m.getX();
            pastY = m.getY();
        }
        else if(Greenfoot.mouseClicked(this))
        {
            MouseInfo m = Greenfoot.getMouseInfo();
            Color current = getImage().getColorAt(m.getX(),m.getY());
            for(int i=0;i<6;i++)
            {
                if(colors[i].equals(current)&&current.getBlue() < 155)
                    colors[i] = new Color(current.getRed(),current.getGreen(),current.getBlue()+100);
                else if(colors[i].equals(current))
                    colors[i] = new Color(current.getRed(),current.getGreen(),current.getBlue()-155);
            }
            draw();
        }
        if(Greenfoot.isKeyDown("e"))
        {
            zAxis(-1);
        }
        else if(Greenfoot.isKeyDown("q"))
        {
            zAxis(1);
        }
        else if(Greenfoot.isKeyDown("w"))
        {
            xAxis(-1);
        }
        else if(Greenfoot.isKeyDown("s"))
        {
            xAxis(1);
        }
        else if(Greenfoot.isKeyDown("a"))
        {
            yAxis(-1);
        }
        else if(Greenfoot.isKeyDown("d"))
        {
            yAxis(1);
        }
        else if(Greenfoot.isKeyDown("up")&&scale<1)
        {
            for(int i=0;i<8;i++)
            {
                zLoc[i] = zLoc[i]*1.01;
                yLoc[i] = yLoc[i]*1.01;
                xLoc[i] = xLoc[i]*1.01;
            }
            scale *= 1.01; 
            draw();
        }
        else if(Greenfoot.isKeyDown("down"))
        {
            for(int i=0;i<8;i++)
            {
                zLoc[i] = zLoc[i]/1.01;
                yLoc[i] = yLoc[i]/1.01;
                xLoc[i] = xLoc[i]/1.01;
                scale /= 1.01;
            }
            draw();
        }
        /*else if(Greenfoot.isKeyDown("j"))
        {
            cubeX--;
            draw();
        }
        else if(Greenfoot.isKeyDown("l"))
        {
            cubeX++;
            draw();
        }
        else if(Greenfoot.isKeyDown("k"))
        {
            cubeY++;
            draw();
        }
        else if(Greenfoot.isKeyDown("i"))
        {
            cubeY--;
            draw();
        }*/
    }    
    public void zAxis(int thing)
    {
        for(int i=0;i<8;i++){
                double x = xLoc[i];
                double y = yLoc[i];
                double dir = Math.toDegrees(Math.atan2(y, x));
                double dist = Math.sqrt(x * x + y * y);
                dir = dir + thing*1;
                double worldX = calculateX(dir, dist);
                double worldY = calculateY(dir, dist);
                xLoc[i] = worldX;
                yLoc[i] = worldY;
            }
        draw();
    }
    public void yAxis(int thing)
    {
        for(int i=0;i<8;i++){
                double x = xLoc[i];
                double y = zLoc[i];
                double dir = Math.toDegrees(Math.atan2(y, x));
                double dist = Math.sqrt(x * x + y * y);
                dir = dir + thing;
                double worldX = calculateX(dir, dist);
                double worldY = calculateY(dir, dist);
                xLoc[i] = worldX;
                zLoc[i] = worldY;
            }
        draw();
    }
    public void xAxis(int thing)
    {
        for(int i=0;i<8;i++){
                double x = yLoc[i];
                double y = zLoc[i];
                double dir = Math.toDegrees(Math.atan2(y, x));
                double dist = Math.sqrt(x * x + y * y);
                dir = dir + thing*1;
                double worldX = calculateX(dir, dist);
                double worldY = calculateY(dir, dist);
                yLoc[i] = worldX;
                zLoc[i] = worldY;
            }
            draw();
    }
    public void draw()
    {
        getImage().setColor(new Color(100,100,100));
        getImage().fill();
        int[] place = new int[6];
        int[][] first = order;
        /*for(int i=0;i<6;i++)
        {
             double dist = (zLoc[order[i][0]]+zLoc[order[i][1]]+zLoc[order[i][2]]+zLoc[order[i][3]])/4;
             place[i] = 0;
             for(int j=0;j<6;j++)
            {
                 if(i!=j){
                     double dist2 = (zLoc[order[j][0]]+zLoc[order[j][1]]+zLoc[order[j][2]]+zLoc[order[j][3]])/4;
                     if(dist2 > dist)
                        place[i]++;
                     else if(dist2<dist)
                        place[i]--;
                    }
            }
        }
        for(int i=0;i<6;i++)
        {
            first[place[i]][0] = order[i][0];
            first[place[i]][1] = order[i][1];
            first[place[i]][2] = order[i][2];
            first[place[i]][3] = order[i][3];
        }*/
        for(int i=0;i<6;i++)
        {
            int s = 2;
            int[] x = {(int)((xLoc[first[i][0]]*400+cubeX)/(zLoc[first[i][0]]+400))*s+300+cubeX,(int)((xLoc[first[i][1]]*400+cubeX)/(zLoc[first[i][1]]+400))*s+300+cubeX,
                (int)((xLoc[first[i][2]]*400+cubeX)/(zLoc[first[i][2]]+400))*s+300+cubeX,(int)((xLoc[first[i][3]]*400+cubeX)/(zLoc[first[i][3]]+400))*s+300+cubeX};
            int[] y = {(int)((yLoc[first[i][0]]*400+cubeY)/(zLoc[first[i][0]]+400))*s+200+cubeY,(int)((yLoc[first[i][1]]*400+cubeY)/(zLoc[first[i][1]]+400))*s+200+cubeY,
                (int)((yLoc[first[i][2]]*400+cubeY)/(zLoc[first[i][2]]+400))*s+200+cubeY,(int)((yLoc[first[i][3]]*400+cubeY)/(zLoc[first[i][3]]+400))*s+200+cubeY};
            getImage().setColor(colors[i]);
            double dist = 
                Math.sqrt(Math.sqrt(Math.pow((zLoc[first[i][0]]+zLoc[first[i][1]]+zLoc[first[i][2]]+zLoc[first[i][3]]+200)/4,2)+
                Math.pow((yLoc[first[i][0]]+yLoc[first[i][1]]+yLoc[first[i][2]]+yLoc[first[i][3]])/4+cubeY,2))
                +Math.pow((xLoc[first[i][0]]+xLoc[first[i][1]]+xLoc[first[i][2]]+xLoc[first[i][3]])/4+cubeX,2));
                double d = (zLoc[first[i][0]]+zLoc[first[i][1]]+zLoc[first[i][2]]+zLoc[first[i][3]])/4;
            float cubeDist = (float)Math.sqrt(cubeX*cubeX+cubeY*cubeY);
            boolean centered = false;
            /*if((xLoc[first[i][0]]+xLoc[first[i][1]]+xLoc[first[i][2]]+xLoc[first[i][3]])/4 > 0 && 
                (yLoc[first[i][0]]+yLoc[first[i][1]]+yLoc[first[i][2]]+yLoc[first[i][3]])/4 > 0)
                centered = (cubeX<((zLoc[first[i][0]]+zLoc[first[i][1]]+zLoc[first[i][2]]+zLoc[first[i][3]])/4)) && 
                    (cubeY<((zLoc[first[i][0]]+zLoc[first[i][1]]+zLoc[first[i][2]]+zLoc[first[i][3]])/4));
            else if((xLoc[first[i][0]]+xLoc[first[i][1]]+xLoc[first[i][2]]+xLoc[first[i][3]])/4 < 0 && 
                (yLoc[first[i][0]]+yLoc[first[i][1]]+yLoc[first[i][2]]+yLoc[first[i][3]])/4 > 0)
                centered = (cubeX>((zLoc[first[i][0]]+zLoc[first[i][1]]+zLoc[first[i][2]]+zLoc[first[i][3]])/4)) && 
                    (cubeY<((zLoc[first[i][0]]+zLoc[first[i][1]]+zLoc[first[i][2]]+zLoc[first[i][3]])/4));
            else if((xLoc[first[i][0]]+xLoc[first[i][1]]+xLoc[first[i][2]]+xLoc[first[i][3]])/4 < 0 && 
                (yLoc[first[i][0]]+yLoc[first[i][1]]+yLoc[first[i][2]]+yLoc[first[i][3]])/4 < 0)
                centered = (cubeX>((zLoc[first[i][0]]+zLoc[first[i][1]]+zLoc[first[i][2]]+zLoc[first[i][3]])/4)) && 
                    (cubeY>((zLoc[first[i][0]]+zLoc[first[i][1]]+zLoc[first[i][2]]+zLoc[first[i][3]])/4));
            else if((xLoc[first[i][0]]+xLoc[first[i][1]]+xLoc[first[i][2]]+xLoc[first[i][3]])/4 > 0 && 
                (yLoc[first[i][0]]+yLoc[first[i][1]]+yLoc[first[i][2]]+yLoc[first[i][3]])/4 < 0)
                centered = (cubeX<((zLoc[first[i][0]]+zLoc[first[i][1]]+zLoc[first[i][2]]+zLoc[first[i][3]])/4)) && 
                    (cubeY>((zLoc[first[i][0]]+zLoc[first[i][1]]+zLoc[first[i][2]]+zLoc[first[i][3]])/4));*/
            if(d< -6*scale || centered)
                getImage().fillPolygon(x,y,4);
        }
        getImage().drawString("Scale: "+scale,100,100);
        /*for(int i=0;i<8;i++)
            getImage().fillOval((int)(xLoc[i]*400/(zLoc[i]+400))+300,(int)(yLoc[i]*400/(zLoc[i]+400))+200,5,5);*/
    }
    private static double calculateX(double dir, double mag)
    {
        return Math.cos(Math.toRadians(dir)) * mag;
    }
    private static double calculateY(double dir, double mag)
    {
        return Math.sin(Math.toRadians(dir)) * mag;
    }
    
}
